// Code generated by go-swagger; DO NOT EDIT.

package event_management

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/Cyclops-Labs/cyclops-4-hpc.git/services/eventsengine/models"
)

// GetStateReader is a Reader for the GetState structure.
type GetStateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetStateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetStateOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 404:
		result := NewGetStateNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetStateInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetStateOK creates a GetStateOK with default headers values
func NewGetStateOK() *GetStateOK {
	return &GetStateOK{}
}

/*GetStateOK handles this case with default header values.

Description of a successfully operation
*/
type GetStateOK struct {
	Payload []*models.State
}

func (o *GetStateOK) Error() string {
	return fmt.Sprintf("[GET /event/status/{account}][%d] getStateOK  %+v", 200, o.Payload)
}

func (o *GetStateOK) GetPayload() []*models.State {
	return o.Payload
}

func (o *GetStateOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetStateNotFound creates a GetStateNotFound with default headers values
func NewGetStateNotFound() *GetStateNotFound {
	return &GetStateNotFound{}
}

/*GetStateNotFound handles this case with default header values.

Item not found in the system
*/
type GetStateNotFound struct {
	Payload *models.ErrorResponse
}

func (o *GetStateNotFound) Error() string {
	return fmt.Sprintf("[GET /event/status/{account}][%d] getStateNotFound  %+v", 404, o.Payload)
}

func (o *GetStateNotFound) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetStateNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetStateInternalServerError creates a GetStateInternalServerError with default headers values
func NewGetStateInternalServerError() *GetStateInternalServerError {
	return &GetStateInternalServerError{}
}

/*GetStateInternalServerError handles this case with default header values.

Something unexpected happend, error raised
*/
type GetStateInternalServerError struct {
	Payload *models.ErrorResponse
}

func (o *GetStateInternalServerError) Error() string {
	return fmt.Sprintf("[GET /event/status/{account}][%d] getStateInternalServerError  %+v", 500, o.Payload)
}

func (o *GetStateInternalServerError) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetStateInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
