// Code generated by go-swagger; DO NOT EDIT.

package invoice_management

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/Cyclops-Labs/cyclops-4-hpc.git/services/billing/models"
)

// GetInvoiceReader is a Reader for the GetInvoice structure.
type GetInvoiceReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetInvoiceReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetInvoiceOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 404:
		result := NewGetInvoiceNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetInvoiceInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetInvoiceOK creates a GetInvoiceOK with default headers values
func NewGetInvoiceOK() *GetInvoiceOK {
	return &GetInvoiceOK{}
}

/*GetInvoiceOK handles this case with default header values.

Description of a successfully operation
*/
type GetInvoiceOK struct {
	Payload *models.Invoice
}

func (o *GetInvoiceOK) Error() string {
	return fmt.Sprintf("[GET /invoice/{id}][%d] getInvoiceOK  %+v", 200, o.Payload)
}

func (o *GetInvoiceOK) GetPayload() *models.Invoice {
	return o.Payload
}

func (o *GetInvoiceOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Invoice)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetInvoiceNotFound creates a GetInvoiceNotFound with default headers values
func NewGetInvoiceNotFound() *GetInvoiceNotFound {
	return &GetInvoiceNotFound{}
}

/*GetInvoiceNotFound handles this case with default header values.

The invoice id provided doesn't exist
*/
type GetInvoiceNotFound struct {
	Payload *models.ErrorResponse
}

func (o *GetInvoiceNotFound) Error() string {
	return fmt.Sprintf("[GET /invoice/{id}][%d] getInvoiceNotFound  %+v", 404, o.Payload)
}

func (o *GetInvoiceNotFound) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetInvoiceNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetInvoiceInternalServerError creates a GetInvoiceInternalServerError with default headers values
func NewGetInvoiceInternalServerError() *GetInvoiceInternalServerError {
	return &GetInvoiceInternalServerError{}
}

/*GetInvoiceInternalServerError handles this case with default header values.

Something unexpected happend, error raised
*/
type GetInvoiceInternalServerError struct {
	Payload *models.ErrorResponse
}

func (o *GetInvoiceInternalServerError) Error() string {
	return fmt.Sprintf("[GET /invoice/{id}][%d] getInvoiceInternalServerError  %+v", 500, o.Payload)
}

func (o *GetInvoiceInternalServerError) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetInvoiceInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
