// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"net/http"
	"strings"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/loads"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/runtime/security"
	"github.com/go-openapi/spec"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/Cyclops-Labs/cyclops-4-hpc.git/services/credit-system/restapi/operations/account_management"
	"github.com/Cyclops-Labs/cyclops-4-hpc.git/services/credit-system/restapi/operations/credit_management"
	"github.com/Cyclops-Labs/cyclops-4-hpc.git/services/credit-system/restapi/operations/status_management"
	"github.com/Cyclops-Labs/cyclops-4-hpc.git/services/credit-system/restapi/operations/trigger_management"
)

// NewCreditManagerManagementAPIAPI creates a new CreditManagerManagementAPI instance
func NewCreditManagerManagementAPIAPI(spec *loads.Document) *CreditManagerManagementAPIAPI {
	return &CreditManagerManagementAPIAPI{
		handlers:            make(map[string]map[string]http.Handler),
		formats:             strfmt.Default,
		defaultConsumes:     "application/json",
		defaultProduces:     "application/json",
		customConsumers:     make(map[string]runtime.Consumer),
		customProducers:     make(map[string]runtime.Producer),
		PreServerShutdown:   func() {},
		ServerShutdown:      func() {},
		spec:                spec,
		useSwaggerUI:        false,
		ServeError:          errors.ServeError,
		BasicAuthenticator:  security.BasicAuth,
		APIKeyAuthenticator: security.APIKeyAuth,
		BearerAuthenticator: security.BearerAuth,

		JSONConsumer: runtime.JSONConsumer(),

		JSONProducer: runtime.JSONProducer(),

		CreditManagementAddConsumptionHandler: credit_management.AddConsumptionHandlerFunc(func(params credit_management.AddConsumptionParams, principal interface{}) middleware.Responder {
			return middleware.NotImplemented("operation credit_management.AddConsumption has not yet been implemented")
		}),
		AccountManagementCreateAccountHandler: account_management.CreateAccountHandlerFunc(func(params account_management.CreateAccountParams, principal interface{}) middleware.Responder {
			return middleware.NotImplemented("operation account_management.CreateAccount has not yet been implemented")
		}),
		CreditManagementDecreaseCreditHandler: credit_management.DecreaseCreditHandlerFunc(func(params credit_management.DecreaseCreditParams, principal interface{}) middleware.Responder {
			return middleware.NotImplemented("operation credit_management.DecreaseCredit has not yet been implemented")
		}),
		AccountManagementDisableAccountHandler: account_management.DisableAccountHandlerFunc(func(params account_management.DisableAccountParams, principal interface{}) middleware.Responder {
			return middleware.NotImplemented("operation account_management.DisableAccount has not yet been implemented")
		}),
		AccountManagementEnableAccountHandler: account_management.EnableAccountHandlerFunc(func(params account_management.EnableAccountParams, principal interface{}) middleware.Responder {
			return middleware.NotImplemented("operation account_management.EnableAccount has not yet been implemented")
		}),
		TriggerManagementExecSampleHandler: trigger_management.ExecSampleHandlerFunc(func(params trigger_management.ExecSampleParams, principal interface{}) middleware.Responder {
			return middleware.NotImplemented("operation trigger_management.ExecSample has not yet been implemented")
		}),
		AccountManagementGetAccountStatusHandler: account_management.GetAccountStatusHandlerFunc(func(params account_management.GetAccountStatusParams, principal interface{}) middleware.Responder {
			return middleware.NotImplemented("operation account_management.GetAccountStatus has not yet been implemented")
		}),
		CreditManagementGetCreditHandler: credit_management.GetCreditHandlerFunc(func(params credit_management.GetCreditParams, principal interface{}) middleware.Responder {
			return middleware.NotImplemented("operation credit_management.GetCredit has not yet been implemented")
		}),
		CreditManagementGetHistoryHandler: credit_management.GetHistoryHandlerFunc(func(params credit_management.GetHistoryParams, principal interface{}) middleware.Responder {
			return middleware.NotImplemented("operation credit_management.GetHistory has not yet been implemented")
		}),
		StatusManagementGetStatusHandler: status_management.GetStatusHandlerFunc(func(params status_management.GetStatusParams, principal interface{}) middleware.Responder {
			return middleware.NotImplemented("operation status_management.GetStatus has not yet been implemented")
		}),
		CreditManagementIncreaseCreditHandler: credit_management.IncreaseCreditHandlerFunc(func(params credit_management.IncreaseCreditParams, principal interface{}) middleware.Responder {
			return middleware.NotImplemented("operation credit_management.IncreaseCredit has not yet been implemented")
		}),
		AccountManagementListAccountsHandler: account_management.ListAccountsHandlerFunc(func(params account_management.ListAccountsParams, principal interface{}) middleware.Responder {
			return middleware.NotImplemented("operation account_management.ListAccounts has not yet been implemented")
		}),
		StatusManagementShowStatusHandler: status_management.ShowStatusHandlerFunc(func(params status_management.ShowStatusParams, principal interface{}) middleware.Responder {
			return middleware.NotImplemented("operation status_management.ShowStatus has not yet been implemented")
		}),

		// Applies when the "X-API-KEY" header is set
		APIKeyHeaderAuth: func(token string) (interface{}, error) {
			return nil, errors.NotImplemented("api key auth (APIKeyHeader) X-API-KEY from header param [X-API-KEY] has not yet been implemented")
		},
		// Applies when the "api_key" query is set
		APIKeyParamAuth: func(token string) (interface{}, error) {
			return nil, errors.NotImplemented("api key auth (APIKeyParam) api_key from query param [api_key] has not yet been implemented")
		},
		KeycloakAuth: func(token string, scopes []string) (interface{}, error) {
			return nil, errors.NotImplemented("oauth2 bearer auth (Keycloak) has not yet been implemented")
		},
		// default authorizer is authorized meaning no requests are blocked
		APIAuthorizer: security.Authorized(),
	}
}

/*CreditManagerManagementAPIAPI An API which supports creation, deletion, listing etc of Credit Manager */
type CreditManagerManagementAPIAPI struct {
	spec            *loads.Document
	context         *middleware.Context
	handlers        map[string]map[string]http.Handler
	formats         strfmt.Registry
	customConsumers map[string]runtime.Consumer
	customProducers map[string]runtime.Producer
	defaultConsumes string
	defaultProduces string
	Middleware      func(middleware.Builder) http.Handler
	useSwaggerUI    bool

	// BasicAuthenticator generates a runtime.Authenticator from the supplied basic auth function.
	// It has a default implementation in the security package, however you can replace it for your particular usage.
	BasicAuthenticator func(security.UserPassAuthentication) runtime.Authenticator
	// APIKeyAuthenticator generates a runtime.Authenticator from the supplied token auth function.
	// It has a default implementation in the security package, however you can replace it for your particular usage.
	APIKeyAuthenticator func(string, string, security.TokenAuthentication) runtime.Authenticator
	// BearerAuthenticator generates a runtime.Authenticator from the supplied bearer token auth function.
	// It has a default implementation in the security package, however you can replace it for your particular usage.
	BearerAuthenticator func(string, security.ScopedTokenAuthentication) runtime.Authenticator

	// JSONConsumer registers a consumer for the following mime types:
	//   - application/json
	JSONConsumer runtime.Consumer

	// JSONProducer registers a producer for the following mime types:
	//   - application/json
	JSONProducer runtime.Producer

	// APIKeyHeaderAuth registers a function that takes a token and returns a principal
	// it performs authentication based on an api key X-API-KEY provided in the header
	APIKeyHeaderAuth func(string) (interface{}, error)

	// APIKeyParamAuth registers a function that takes a token and returns a principal
	// it performs authentication based on an api key api_key provided in the query
	APIKeyParamAuth func(string) (interface{}, error)

	// KeycloakAuth registers a function that takes an access token and a collection of required scopes and returns a principal
	// it performs authentication based on an oauth2 bearer token provided in the request
	KeycloakAuth func(string, []string) (interface{}, error)

	// APIAuthorizer provides access control (ACL/RBAC/ABAC) by providing access to the request and authenticated principal
	APIAuthorizer runtime.Authorizer

	// CreditManagementAddConsumptionHandler sets the operation handler for the add consumption operation
	CreditManagementAddConsumptionHandler credit_management.AddConsumptionHandler
	// AccountManagementCreateAccountHandler sets the operation handler for the create account operation
	AccountManagementCreateAccountHandler account_management.CreateAccountHandler
	// CreditManagementDecreaseCreditHandler sets the operation handler for the decrease credit operation
	CreditManagementDecreaseCreditHandler credit_management.DecreaseCreditHandler
	// AccountManagementDisableAccountHandler sets the operation handler for the disable account operation
	AccountManagementDisableAccountHandler account_management.DisableAccountHandler
	// AccountManagementEnableAccountHandler sets the operation handler for the enable account operation
	AccountManagementEnableAccountHandler account_management.EnableAccountHandler
	// TriggerManagementExecSampleHandler sets the operation handler for the exec sample operation
	TriggerManagementExecSampleHandler trigger_management.ExecSampleHandler
	// AccountManagementGetAccountStatusHandler sets the operation handler for the get account status operation
	AccountManagementGetAccountStatusHandler account_management.GetAccountStatusHandler
	// CreditManagementGetCreditHandler sets the operation handler for the get credit operation
	CreditManagementGetCreditHandler credit_management.GetCreditHandler
	// CreditManagementGetHistoryHandler sets the operation handler for the get history operation
	CreditManagementGetHistoryHandler credit_management.GetHistoryHandler
	// StatusManagementGetStatusHandler sets the operation handler for the get status operation
	StatusManagementGetStatusHandler status_management.GetStatusHandler
	// CreditManagementIncreaseCreditHandler sets the operation handler for the increase credit operation
	CreditManagementIncreaseCreditHandler credit_management.IncreaseCreditHandler
	// AccountManagementListAccountsHandler sets the operation handler for the list accounts operation
	AccountManagementListAccountsHandler account_management.ListAccountsHandler
	// StatusManagementShowStatusHandler sets the operation handler for the show status operation
	StatusManagementShowStatusHandler status_management.ShowStatusHandler
	// ServeError is called when an error is received, there is a default handler
	// but you can set your own with this
	ServeError func(http.ResponseWriter, *http.Request, error)

	// PreServerShutdown is called before the HTTP(S) server is shutdown
	// This allows for custom functions to get executed before the HTTP(S) server stops accepting traffic
	PreServerShutdown func()

	// ServerShutdown is called when the HTTP(S) server is shut down and done
	// handling all active connections and does not accept connections any more
	ServerShutdown func()

	// Custom command line argument groups with their descriptions
	CommandLineOptionsGroups []swag.CommandLineOptionsGroup

	// User defined logger function.
	Logger func(string, ...interface{})
}

// UseRedoc for documentation at /docs
func (o *CreditManagerManagementAPIAPI) UseRedoc() {
	o.useSwaggerUI = false
}

// UseSwaggerUI for documentation at /docs
func (o *CreditManagerManagementAPIAPI) UseSwaggerUI() {
	o.useSwaggerUI = true
}

// SetDefaultProduces sets the default produces media type
func (o *CreditManagerManagementAPIAPI) SetDefaultProduces(mediaType string) {
	o.defaultProduces = mediaType
}

// SetDefaultConsumes returns the default consumes media type
func (o *CreditManagerManagementAPIAPI) SetDefaultConsumes(mediaType string) {
	o.defaultConsumes = mediaType
}

// SetSpec sets a spec that will be served for the clients.
func (o *CreditManagerManagementAPIAPI) SetSpec(spec *loads.Document) {
	o.spec = spec
}

// DefaultProduces returns the default produces media type
func (o *CreditManagerManagementAPIAPI) DefaultProduces() string {
	return o.defaultProduces
}

// DefaultConsumes returns the default consumes media type
func (o *CreditManagerManagementAPIAPI) DefaultConsumes() string {
	return o.defaultConsumes
}

// Formats returns the registered string formats
func (o *CreditManagerManagementAPIAPI) Formats() strfmt.Registry {
	return o.formats
}

// RegisterFormat registers a custom format validator
func (o *CreditManagerManagementAPIAPI) RegisterFormat(name string, format strfmt.Format, validator strfmt.Validator) {
	o.formats.Add(name, format, validator)
}

// Validate validates the registrations in the CreditManagerManagementAPIAPI
func (o *CreditManagerManagementAPIAPI) Validate() error {
	var unregistered []string

	if o.JSONConsumer == nil {
		unregistered = append(unregistered, "JSONConsumer")
	}

	if o.JSONProducer == nil {
		unregistered = append(unregistered, "JSONProducer")
	}

	if o.APIKeyHeaderAuth == nil {
		unregistered = append(unregistered, "XAPIKEYAuth")
	}
	if o.APIKeyParamAuth == nil {
		unregistered = append(unregistered, "APIKeyAuth")
	}
	if o.KeycloakAuth == nil {
		unregistered = append(unregistered, "KeycloakAuth")
	}

	if o.CreditManagementAddConsumptionHandler == nil {
		unregistered = append(unregistered, "credit_management.AddConsumptionHandler")
	}
	if o.AccountManagementCreateAccountHandler == nil {
		unregistered = append(unregistered, "account_management.CreateAccountHandler")
	}
	if o.CreditManagementDecreaseCreditHandler == nil {
		unregistered = append(unregistered, "credit_management.DecreaseCreditHandler")
	}
	if o.AccountManagementDisableAccountHandler == nil {
		unregistered = append(unregistered, "account_management.DisableAccountHandler")
	}
	if o.AccountManagementEnableAccountHandler == nil {
		unregistered = append(unregistered, "account_management.EnableAccountHandler")
	}
	if o.TriggerManagementExecSampleHandler == nil {
		unregistered = append(unregistered, "trigger_management.ExecSampleHandler")
	}
	if o.AccountManagementGetAccountStatusHandler == nil {
		unregistered = append(unregistered, "account_management.GetAccountStatusHandler")
	}
	if o.CreditManagementGetCreditHandler == nil {
		unregistered = append(unregistered, "credit_management.GetCreditHandler")
	}
	if o.CreditManagementGetHistoryHandler == nil {
		unregistered = append(unregistered, "credit_management.GetHistoryHandler")
	}
	if o.StatusManagementGetStatusHandler == nil {
		unregistered = append(unregistered, "status_management.GetStatusHandler")
	}
	if o.CreditManagementIncreaseCreditHandler == nil {
		unregistered = append(unregistered, "credit_management.IncreaseCreditHandler")
	}
	if o.AccountManagementListAccountsHandler == nil {
		unregistered = append(unregistered, "account_management.ListAccountsHandler")
	}
	if o.StatusManagementShowStatusHandler == nil {
		unregistered = append(unregistered, "status_management.ShowStatusHandler")
	}

	if len(unregistered) > 0 {
		return fmt.Errorf("missing registration: %s", strings.Join(unregistered, ", "))
	}

	return nil
}

// ServeErrorFor gets a error handler for a given operation id
func (o *CreditManagerManagementAPIAPI) ServeErrorFor(operationID string) func(http.ResponseWriter, *http.Request, error) {
	return o.ServeError
}

// AuthenticatorsFor gets the authenticators for the specified security schemes
func (o *CreditManagerManagementAPIAPI) AuthenticatorsFor(schemes map[string]spec.SecurityScheme) map[string]runtime.Authenticator {
	result := make(map[string]runtime.Authenticator)
	for name := range schemes {
		switch name {
		case "APIKeyHeader":
			scheme := schemes[name]
			result[name] = o.APIKeyAuthenticator(scheme.Name, scheme.In, o.APIKeyHeaderAuth)

		case "APIKeyParam":
			scheme := schemes[name]
			result[name] = o.APIKeyAuthenticator(scheme.Name, scheme.In, o.APIKeyParamAuth)

		case "Keycloak":
			result[name] = o.BearerAuthenticator(name, o.KeycloakAuth)

		}
	}
	return result
}

// Authorizer returns the registered authorizer
func (o *CreditManagerManagementAPIAPI) Authorizer() runtime.Authorizer {
	return o.APIAuthorizer
}

// ConsumersFor gets the consumers for the specified media types.
// MIME type parameters are ignored here.
func (o *CreditManagerManagementAPIAPI) ConsumersFor(mediaTypes []string) map[string]runtime.Consumer {
	result := make(map[string]runtime.Consumer, len(mediaTypes))
	for _, mt := range mediaTypes {
		switch mt {
		case "application/json":
			result["application/json"] = o.JSONConsumer
		}

		if c, ok := o.customConsumers[mt]; ok {
			result[mt] = c
		}
	}
	return result
}

// ProducersFor gets the producers for the specified media types.
// MIME type parameters are ignored here.
func (o *CreditManagerManagementAPIAPI) ProducersFor(mediaTypes []string) map[string]runtime.Producer {
	result := make(map[string]runtime.Producer, len(mediaTypes))
	for _, mt := range mediaTypes {
		switch mt {
		case "application/json":
			result["application/json"] = o.JSONProducer
		}

		if p, ok := o.customProducers[mt]; ok {
			result[mt] = p
		}
	}
	return result
}

// HandlerFor gets a http.Handler for the provided operation method and path
func (o *CreditManagerManagementAPIAPI) HandlerFor(method, path string) (http.Handler, bool) {
	if o.handlers == nil {
		return nil, false
	}
	um := strings.ToUpper(method)
	if _, ok := o.handlers[um]; !ok {
		return nil, false
	}
	if path == "/" {
		path = ""
	}
	h, ok := o.handlers[um][path]
	return h, ok
}

// Context returns the middleware context for the credit manager management API API
func (o *CreditManagerManagementAPIAPI) Context() *middleware.Context {
	if o.context == nil {
		o.context = middleware.NewRoutableContext(o.spec, o, nil)
	}

	return o.context
}

func (o *CreditManagerManagementAPIAPI) initHandlerCache() {
	o.Context() // don't care about the result, just that the initialization happened
	if o.handlers == nil {
		o.handlers = make(map[string]map[string]http.Handler)
	}

	if o.handlers["POST"] == nil {
		o.handlers["POST"] = make(map[string]http.Handler)
	}
	o.handlers["POST"]["/{medium}/consume/{id}"] = credit_management.NewAddConsumption(o.context, o.CreditManagementAddConsumptionHandler)
	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/account/create/{id}"] = account_management.NewCreateAccount(o.context, o.AccountManagementCreateAccountHandler)
	if o.handlers["POST"] == nil {
		o.handlers["POST"] = make(map[string]http.Handler)
	}
	o.handlers["POST"]["/{medium}/available/decrease/{id}"] = credit_management.NewDecreaseCredit(o.context, o.CreditManagementDecreaseCreditHandler)
	if o.handlers["POST"] == nil {
		o.handlers["POST"] = make(map[string]http.Handler)
	}
	o.handlers["POST"]["/account/disable/{id}"] = account_management.NewDisableAccount(o.context, o.AccountManagementDisableAccountHandler)
	if o.handlers["POST"] == nil {
		o.handlers["POST"] = make(map[string]http.Handler)
	}
	o.handlers["POST"]["/account/enable/{id}"] = account_management.NewEnableAccount(o.context, o.AccountManagementEnableAccountHandler)
	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/trigger/sample"] = trigger_management.NewExecSample(o.context, o.TriggerManagementExecSampleHandler)
	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/account/status/{id}"] = account_management.NewGetAccountStatus(o.context, o.AccountManagementGetAccountStatusHandler)
	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/account/available/{id}"] = credit_management.NewGetCredit(o.context, o.CreditManagementGetCreditHandler)
	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/history/{id}"] = credit_management.NewGetHistory(o.context, o.CreditManagementGetHistoryHandler)
	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/status/{id}"] = status_management.NewGetStatus(o.context, o.StatusManagementGetStatusHandler)
	if o.handlers["POST"] == nil {
		o.handlers["POST"] = make(map[string]http.Handler)
	}
	o.handlers["POST"]["/{medium}/available/increase/{id}"] = credit_management.NewIncreaseCredit(o.context, o.CreditManagementIncreaseCreditHandler)
	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/account/list"] = account_management.NewListAccounts(o.context, o.AccountManagementListAccountsHandler)
	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/status"] = status_management.NewShowStatus(o.context, o.StatusManagementShowStatusHandler)
}

// Serve creates a http handler to serve the API over HTTP
// can be used directly in http.ListenAndServe(":8000", api.Serve(nil))
func (o *CreditManagerManagementAPIAPI) Serve(builder middleware.Builder) http.Handler {
	o.Init()

	if o.Middleware != nil {
		return o.Middleware(builder)
	}
	if o.useSwaggerUI {
		return o.context.APIHandlerSwaggerUI(builder)
	}
	return o.context.APIHandler(builder)
}

// Init allows you to just initialize the handler cache, you can then recompose the middleware as you see fit
func (o *CreditManagerManagementAPIAPI) Init() {
	if len(o.handlers) == 0 {
		o.initHandlerCache()
	}
}

// RegisterConsumer allows you to add (or override) a consumer for a media type.
func (o *CreditManagerManagementAPIAPI) RegisterConsumer(mediaType string, consumer runtime.Consumer) {
	o.customConsumers[mediaType] = consumer
}

// RegisterProducer allows you to add (or override) a producer for a media type.
func (o *CreditManagerManagementAPIAPI) RegisterProducer(mediaType string, producer runtime.Producer) {
	o.customProducers[mediaType] = producer
}

// AddMiddlewareFor adds a http middleware to existing handler
func (o *CreditManagerManagementAPIAPI) AddMiddlewareFor(method, path string, builder middleware.Builder) {
	um := strings.ToUpper(method)
	if path == "/" {
		path = ""
	}
	o.Init()
	if h, ok := o.handlers[um][path]; ok {
		o.handlers[method][path] = builder(h)
	}
}
