// Code generated by go-swagger; DO NOT EDIT.

package customer_management

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/Cyclops-Labs/cyclops-4-hpc.git/services/customerdb/models"
)

// GetCustomerReader is a Reader for the GetCustomer structure.
type GetCustomerReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCustomerReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetCustomerOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 404:
		result := NewGetCustomerNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetCustomerInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCustomerOK creates a GetCustomerOK with default headers values
func NewGetCustomerOK() *GetCustomerOK {
	return &GetCustomerOK{}
}

/*GetCustomerOK handles this case with default header values.

Customer with the id given in the system returned
*/
type GetCustomerOK struct {
	Payload *models.Customer
}

func (o *GetCustomerOK) Error() string {
	return fmt.Sprintf("[GET /customer/{id}][%d] getCustomerOK  %+v", 200, o.Payload)
}

func (o *GetCustomerOK) GetPayload() *models.Customer {
	return o.Payload
}

func (o *GetCustomerOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Customer)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCustomerNotFound creates a GetCustomerNotFound with default headers values
func NewGetCustomerNotFound() *GetCustomerNotFound {
	return &GetCustomerNotFound{}
}

/*GetCustomerNotFound handles this case with default header values.

The customer with the given id wasn't found
*/
type GetCustomerNotFound struct {
	Payload *models.ErrorResponse
}

func (o *GetCustomerNotFound) Error() string {
	return fmt.Sprintf("[GET /customer/{id}][%d] getCustomerNotFound  %+v", 404, o.Payload)
}

func (o *GetCustomerNotFound) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetCustomerNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCustomerInternalServerError creates a GetCustomerInternalServerError with default headers values
func NewGetCustomerInternalServerError() *GetCustomerInternalServerError {
	return &GetCustomerInternalServerError{}
}

/*GetCustomerInternalServerError handles this case with default header values.

Something unexpected happend, error raised
*/
type GetCustomerInternalServerError struct {
	Payload *models.ErrorResponse
}

func (o *GetCustomerInternalServerError) Error() string {
	return fmt.Sprintf("[GET /customer/{id}][%d] getCustomerInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCustomerInternalServerError) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetCustomerInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
