// Code generated by go-swagger; DO NOT EDIT.

package price_management

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/Cyclops-Labs/cyclops-4-hpc.git/services/plan-manager/models"
)

// GetSkuPriceReader is a Reader for the GetSkuPrice structure.
type GetSkuPriceReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetSkuPriceReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetSkuPriceOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 404:
		result := NewGetSkuPriceNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetSkuPriceInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewGetSkuPriceOK creates a GetSkuPriceOK with default headers values
func NewGetSkuPriceOK() *GetSkuPriceOK {
	return &GetSkuPriceOK{}
}

/*GetSkuPriceOK handles this case with default header values.

sku price returned
*/
type GetSkuPriceOK struct {
	Payload *models.SkuPrice
}

func (o *GetSkuPriceOK) Error() string {
	return fmt.Sprintf("[GET /sku/price/{id}][%d] getSkuPriceOK  %+v", 200, o.Payload)
}

func (o *GetSkuPriceOK) GetPayload() *models.SkuPrice {
	return o.Payload
}

func (o *GetSkuPriceOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.SkuPrice)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetSkuPriceNotFound creates a GetSkuPriceNotFound with default headers values
func NewGetSkuPriceNotFound() *GetSkuPriceNotFound {
	return &GetSkuPriceNotFound{}
}

/*GetSkuPriceNotFound handles this case with default header values.

sku price with skupriceid not found
*/
type GetSkuPriceNotFound struct {
	Payload *models.ErrorResponse
}

func (o *GetSkuPriceNotFound) Error() string {
	return fmt.Sprintf("[GET /sku/price/{id}][%d] getSkuPriceNotFound  %+v", 404, o.Payload)
}

func (o *GetSkuPriceNotFound) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetSkuPriceNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetSkuPriceInternalServerError creates a GetSkuPriceInternalServerError with default headers values
func NewGetSkuPriceInternalServerError() *GetSkuPriceInternalServerError {
	return &GetSkuPriceInternalServerError{}
}

/*GetSkuPriceInternalServerError handles this case with default header values.

unexpected error
*/
type GetSkuPriceInternalServerError struct {
	Payload *models.ErrorResponse
}

func (o *GetSkuPriceInternalServerError) Error() string {
	return fmt.Sprintf("[GET /sku/price/{id}][%d] getSkuPriceInternalServerError  %+v", 500, o.Payload)
}

func (o *GetSkuPriceInternalServerError) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GetSkuPriceInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
