// Code generated by go-swagger; DO NOT EDIT.

package sku_management

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/Cyclops-Labs/cyclops-4-hpc.git/services/plan-manager/models"
)

// CreateSkuReader is a Reader for the CreateSku structure.
type CreateSkuReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *CreateSkuReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewCreateSkuCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewCreateSkuBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 409:
		result := NewCreateSkuConflict()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewCreateSkuInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewCreateSkuCreated creates a CreateSkuCreated with default headers values
func NewCreateSkuCreated() *CreateSkuCreated {
	return &CreateSkuCreated{}
}

/*CreateSkuCreated handles this case with default header values.

item created
*/
type CreateSkuCreated struct {
	Payload *models.ItemCreatedResponse
}

func (o *CreateSkuCreated) Error() string {
	return fmt.Sprintf("[POST /sku][%d] createSkuCreated  %+v", 201, o.Payload)
}

func (o *CreateSkuCreated) GetPayload() *models.ItemCreatedResponse {
	return o.Payload
}

func (o *CreateSkuCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ItemCreatedResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateSkuBadRequest creates a CreateSkuBadRequest with default headers values
func NewCreateSkuBadRequest() *CreateSkuBadRequest {
	return &CreateSkuBadRequest{}
}

/*CreateSkuBadRequest handles this case with default header values.

invalid input, object invalid
*/
type CreateSkuBadRequest struct {
}

func (o *CreateSkuBadRequest) Error() string {
	return fmt.Sprintf("[POST /sku][%d] createSkuBadRequest ", 400)
}

func (o *CreateSkuBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewCreateSkuConflict creates a CreateSkuConflict with default headers values
func NewCreateSkuConflict() *CreateSkuConflict {
	return &CreateSkuConflict{}
}

/*CreateSkuConflict handles this case with default header values.

an existing item already exists
*/
type CreateSkuConflict struct {
	Payload *models.ErrorResponse
}

func (o *CreateSkuConflict) Error() string {
	return fmt.Sprintf("[POST /sku][%d] createSkuConflict  %+v", 409, o.Payload)
}

func (o *CreateSkuConflict) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *CreateSkuConflict) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateSkuInternalServerError creates a CreateSkuInternalServerError with default headers values
func NewCreateSkuInternalServerError() *CreateSkuInternalServerError {
	return &CreateSkuInternalServerError{}
}

/*CreateSkuInternalServerError handles this case with default header values.

unexpected error
*/
type CreateSkuInternalServerError struct {
	Payload *models.ErrorResponse
}

func (o *CreateSkuInternalServerError) Error() string {
	return fmt.Sprintf("[POST /sku][%d] createSkuInternalServerError  %+v", 500, o.Payload)
}

func (o *CreateSkuInternalServerError) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *CreateSkuInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
